unit Help;

interface

uses
  System.SysUtils, System.Classes, WEBLib.CDS, WEBLib.Cookies, WEBLib.Modules;

type
  TDataModule1 = class(TWebDataModule)

  private
    { Private declarations }
  public
    procedure setBearerHeader(requestRef: TWebClientConnection);
    function GetCookie(cookie_name: string): string;
  end;

var
  DataModule1: TDataModule1;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}
procedure TDataModule1.setBearerHeader(requestRef: TWebClientConnection);
begin
requestRef.Headers.AddPair('authorization', 'Bearer ' + GetCookie('bearer'));
end;
function TDataModule1.GetCookie(cookie_name: string): string;
var
  Cookies: TCookies;
  Cookie: TCookie;
begin
  Result := '';
  Cookies := TCookies.Create;
  try
    Cookies.GetCookies;
    Cookie := Cookies.Find(cookie_name);
    if Assigned(Cookie) then
      Result := Cookie.Value;
  finally
    Cookies.Free;
  end;
end;

end.
