unit Main;

interface

uses
  System.SysUtils,System.StrUtils, System.Classes, JS, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs,WEBLib.REST, Vcl.Controls, Vcl.StdCtrls, WEBLib.StdCtrls, WEBLib.DropDown, Vcl.Menus, WEBLib.Menus,
  WEBLib.ComCtrls, WEBLib.JQCtrls, WEBLib.CDS, Data.DB, WEBLib.DB,WEBLib.WebTools, WEBLib.WebCtrls;

type
  TForm1 = class(TWebForm)
    cu_number: TWebEdit;
    CustomerNumber: TWebLabel;
    CustomerName: TWebLabel;
    cu_name1: TWebEdit;
    cu_name2: TWebEdit;
    CustomerName2: TWebLabel;
    Attn: TWebLabel;
    cu_attn: TWebEdit;
    CustomerAddress1: TWebLabel;
    cu_address1: TWebEdit;
    CustomerAddress2: TWebLabel;
    cu_address2: TWebEdit;
    City: TWebLabel;
    cu_city: TWebEdit;
    Province: TWebLabel;
    Country: TWebLabel;
    PostalCode: TWebLabel;
    cu_postalcode: TWebEdit;
    PhoneNumber: TWebLabel;
    cu_phonenumber: TWebEdit;
    CustomerNationalNumber: TWebLabel;
    cu_nationalnumber: TWebEdit;
    btn_update: TWebButton;
    ConnectionMain: TWebClientConnection;
    MainDataset: TWebClientDataSet;
    WebLabel1: TWebLabel;
    cu_faxnumber: TWebEdit;
    SaleRep: TWebLabel;
    FCS: TWebLabel;
    cu_fcs: TWebEdit;
    Currency: TWebLabel;
    Language: TWebLabel;
    ConnectionGenSR: TWebClientConnection;
    GenSRDataset: TWebClientDataSet;
    cu_country: TWebComboBox;
    cu_province: TWebComboBox;
    cu_salerep: TWebComboBox;
    cu_currency: TWebComboBox;
    ConnectionGenCurrencies: TWebClientConnection;
    GenCurrenciesDataset: TWebClientDataSet;
    ConnectionGenCountries: TWebClientConnection;
    GenCountriesDataset: TWebClientDataSet;
    ConnectionGenProvinces: TWebClientConnection;
    GenProvincesDataset: TWebClientDataSet;
    btn_editmode: TWebButton;
    ConnectionGenLanguages: TWebClientConnection;
    GenLanguagesDataset: TWebClientDataSet;
    cu_language: TWebComboBox;
    ConnectionMainFieldsPost: TWebClientConnection;
    cu_phonenumberext: TWebEdit;
    cu_website: TWebEdit;
    Website: TWebLabel;
    Email: TWebLabel;
    cu_email: TWebEdit;
    EmailGen: TWebLabel;
    cu_emailgen: TWebEdit;
    EmailStat: TWebLabel;
    cu_emailstat: TWebEdit;
    Provenance: TWebLabel;
    cu_provenance: TWebComboBox;
    Category: TWebLabel;
    cu_category: TWebComboBox;
    Category2: TWebLabel;
    cu_category2: TWebComboBox;
    cu_ref: TWebComboBox;
    CustomerReference: TWebLabel;
    ConnectionGenCustSource: TWebClientConnection;
    GenCustSource: TWebClientDataSet;
    ConnectionGenCat1: TWebClientConnection;
    GenCat1: TWebClientDataSet;
    ConnectionGenCat2: TWebClientConnection;
    GenCat2: TWebClientDataSet;
    procedure setMainParameters(Sender: TObject);
    procedure setGenSRParameters(Sender: TObject);
    procedure fillCountries(DataSet: TDataSet);
    procedure fillProvinces();
    procedure fillCurrencies(DataSet: TDataSet);
    [async] procedure fillFields();
    procedure fillCustSource(DataSet: TDataSet);
    procedure switchEditModeFields(Sender: TObject);
    procedure fillLanguages(DataSet: TDataSet);
    procedure updateMainFields(Sender: TObject);
    procedure setGenCustSourceParameters(Sender: TObject);
    function FindFirstItem(InputString: string): string;
    [async] function fillDependentFields(): string;
    procedure fillCat(DataSet: TDataSet);
    procedure fillCat2(DataSet: TDataSet);
    procedure setGenCat2Parameters(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
function TForm1.FindFirstItem(InputString: string): string;
var
  OutputString: string;
  PositionOfEquals: Integer;
begin
// Find the position of the '=' character in the string
  PositionOfEquals := Pos('=', InputString);

  // Check if the '=' character was found
  if PositionOfEquals > 0 then
  begin
    // Extract the substring from the beginning up to (but not including) the '='
    OutputString := Copy(InputString, 1, PositionOfEquals - 1);
  end
  else
  begin
    // If '=' is not found, handle accordingly (e.g., use the whole string or clear OutputString)
    OutputString := InputString; // Or OutputString := ''; depending on requirements
  end;
  Result:= OutputString;
end;


procedure TForm1.fillCat(DataSet: TDataSet);
begin
GenCat1.First;
while not GenCat1.Eof do
  begin
    cu_category.Items.AddPair(GenCat1.FieldByName('CU090IDNO').AsString,GenCat1.FieldByName('CU090DESC').AsString);
    GenCat1.Next;
  end;
  if Assigned(MainDataSet.FindField('FCat1')) then
  begin
     cu_category.ItemIndex:= cu_category.Items.IndexOfName(MainDataSet.FieldByName('FCat1').AsString);
     ConnectionGenCat2.Active := true;
  end;
   
end;

procedure TForm1.fillCat2(DataSet: TDataSet);
begin
GenCat2.First;
while not GenCat2.Eof do
  begin
    cu_category.Items.AddPair(GenCat2.FieldByName('CU090IDNO').AsString,GenCat2.FieldByName('CU090DESC').AsString);
    GenCat1.Next;
  end;
   cu_category2.ItemIndex:= cu_category2.Items.IndexOfName(MainDataSet.FieldByName('FCat2').AsString);
end;
procedure TForm1.fillCountries(DataSet: TDataSet);
begin
GenCountriesDataset.Open;
GenCountriesDataset.First;
  while not GenCountriesDataset.Eof do
  begin
    cu_country.Items.AddPair(GenCountriesDataset.FieldByName('PV005COUNT').AsString,GenCountriesDataset.FieldByName('PV005DESC').AsString);
    GenCountriesDataset.Next;
  end;
   cu_country.ItemIndex:= cu_country.Items.IndexOfName(MainDataSet.FieldByName('FCountry').AsString);
   fillProvinces();
end;
procedure TForm1.fillProvinces();
begin
ConnectionGenProvinces.URI := Format('http://localhost:2001/tms/xdata/CrmService/GetGenProvinces?pv001count=%s', [FindFirstItem(cu_country.Text)]);
ConnectionGenProvinces.Active := true;
 while not GenProvincesDataset.Eof do
  begin
    cu_province.Items.AddPair(GenProvincesDataset.FieldByName('PV001PROV').AsString,GenProvincesDataset.FieldByName('PV001DESC').AsString);
    GenProvincesDataset.Next;
  end;
  cu_province.ItemIndex:= cu_province.Items.IndexOfName(MainDataSet.FieldByName('FProvinceState').AsString);
end;
procedure TForm1.fillCurrencies(DataSet: TDataSet);
begin
GenCurrenciesDataset.Open;
GenCurrenciesDataset.First;
  while not GenCurrenciesDataset.Eof do
  begin
    cu_currency.Items.AddPair(GenCurrenciesDataset.FieldByName('CO040CODE').AsString,GenCurrenciesDataset.FieldByName('CO040DESC').AsString);
    GenCurrenciesDataset.Next;
  end;
  cu_currency.ItemIndex:= cu_currency.Items.IndexOfName(MainDataSet.FieldByName('FCurrency').AsString);
end;

procedure TForm1.fillFields();
var
  Field: TField;
  dummyResult: string;
begin
  dummyResult:= await(fillDependentFields);

  Field := MainDataset.FindField('FNumber');
  if Assigned(Field) then
    cu_number.Text := Field.AsString;

  Field := MainDataset.FindField('FCustomerNationalAccount');
  if Assigned(Field) then
    cu_nationalnumber.Text := Field.AsString;

  Field := MainDataset.FindField('FName');
  if Assigned(Field) then
    cu_name1.Text := Field.AsString;

  Field := MainDataset.FindField('FName2');
  if Assigned(Field) then
    cu_name2.Text := Field.AsString;

  Field := MainDataset.FindField('FAttn');
  if Assigned(Field) then
    cu_attn.Text := Field.AsString;

  Field := MainDataset.FindField('FAdr1');
  if Assigned(Field) then
    cu_address1.Text := Field.AsString;

  Field := MainDataset.FindField('FAdr2');
  if Assigned(Field) then
    cu_address2.Text := Field.AsString;

  Field := MainDataset.FindField('FCity');
  if Assigned(Field) then
    cu_city.Text := Field.AsString;

  Field := MainDataset.FindField('FWeb');
  if Assigned(Field) then
    cu_website.Text := Field.AsString;

  Field := MainDataset.FindField('FReferenceNo1');
  if Assigned(Field) then
    cu_ref.Text := Field.AsString;

  Field := MainDataset.FindField('FCustomerSource');
  if Assigned(Field) then
    cu_provenance.Text := Field.AsString;

  Field := MainDataset.FindField('FTelephoneExtension');
  if Assigned(Field) then
    cu_phonenumberext.Text := Field.AsString;

  Field := MainDataset.FindField('FCat1');
  if Assigned(Field) then
    cu_category.Text := Field.AsString;

  Field := MainDataset.FindField('FCat2');
  if Assigned(Field) then
    cu_category2.Text := Field.AsString;

  Field := MainDataset.FindField('FPostalCode');
  if Assigned(Field) then
    cu_postalcode.Text := Field.AsString;

  Field := MainDataset.FindField('FTelephone');
  if Assigned(Field) then
    cu_phonenumber.Text := Field.AsString;

  Field := MainDataset.FindField('FEmail');
  if Assigned(Field) then
    cu_email.Text := Field.AsString;

  Field := MainDataset.FindField('FEmailStatement');
  if Assigned(Field) then
    cu_emailstat.Text := Field.AsString;

  Field := MainDataset.FindField('FEmailGeneral');
  if Assigned(Field) then
    cu_emailgen.Text := Field.AsString;

  Field := MainDataset.FindField('FSaleRep');
  if Assigned(Field) then
    cu_salerep.Text := Field.AsString;

  Field := MainDataset.FindField('FCs');
  if Assigned(Field) then
    cu_fcs.Text := Field.AsString;

  Field := MainDataset.FindField('FLanguage');
  if Assigned(Field) then
    WriteLn('Entered 2');
    cu_language.Text := Field.AsString;
    WriteLn('Inside mainfield request: ' + cu_language.Text);

  Field := MainDataset.FindField('FFax');
  if Assigned(Field) then
  begin
    cu_faxnumber.Text := Field.AsString;
  end;

end;

procedure TForm1.fillLanguages(DataSet: TDataSet);
begin
 WriteLn('Entered 1');
 GenLanguagesDataset.First;
  while not GenLanguagesDataset.Eof do
  begin
    cu_language.Items.AddPair(GenLanguagesDataset.FieldByName('CO090LANG').AsString,GenLanguagesDataset.FieldByName('CO090DESC').AsString);
    GenLanguagesDataset.Next;
  end;
  cu_language.ItemIndex:= cu_language.Items.IndexOfName(MainDataSet.FieldByName('FLanguage').AsString);
  fillFields();
  end;

procedure TForm1.fillCustSource(DataSet: TDataSet) ;
begin
GenCustSource.First;
  while not GenCustSource.Eof do
  begin
    cu_provenance.Items.AddPair(GenCustSource.FieldByName('CU080IDNO').AsString,GenCustSource.FieldByName('CU080DESC').AsString);
    GenCustSource.Next;
  end;
  if Assigned(GenCustSource.FindField('FSaleRep')) then
  begin
  cu_provenance.ItemIndex:= cu_provenance.Items.IndexOfName(GenCustSource.FieldByName('FSaleRep').AsString);
  end;
end;

function TForm1.fillDependentFields():string;
begin
 ConnectionGenLanguages.Active := True;
 ConnectionGenCurrencies.Active := True;
 ConnectionGenCountries.Active := True;
 ConnectionGenCustSource.Active := true;
 Result:= 'ok';
end;

procedure TForm1.setGenCat2Parameters(Sender: TObject);
begin
ConnectionGenCat2.URI := Format('http://localhost:2001/tms/xdata/CrmService/GetGenCat2?cu090idno=%s',[FindFirstItem(cu_category.Text)]);
end;

procedure TForm1.setGenCustSourceParameters(Sender: TObject);
begin
WriteLn(cu_language.Text);
ConnectionGenCustSource.URI := Format('http://localhost:2001/tms/xdata/CrmService/GetGenCustSource?co090lang=%s',[FindFirstItem(cu_language.Text)]);
end;

procedure TForm1.setGenSRParameters(Sender: TObject);
var param1: string;
begin
  param1 := GetQueryParam('co001comp');
  if param1 = '' then
  //Envoyer user a la page precedente car aucun parametre fournis
  else
  ConnectionGenSR.URI := Format('http://localhost:2001/tms/xdata/CrmService/GetGenSR?co001comp=%s', [param1]);
end;



procedure TForm1.setMainParameters(Sender: TObject);
var param1: string;
param2: string;
begin
  param1 := GetQueryParam('co001comp');
  if param1 = '' then
  //Envoyer user a la page precedente car aucun parametre fournis
  else
  param2 := GetQueryParam('cu001idno');
  ConnectionMain.URI := Format('http://localhost:2001/tms/xdata/CrmService/GetMainFields?co001comp=%s&cu001idno=%s', [param1, param2]);
end;
procedure TForm1.switchEditModeFields(Sender: TObject);
var areFieldsEnabled: boolean;
begin
if cu_name1.enabled then
areFieldsEnabled := true
else
areFieldsEnabled := false;
 cu_country.Enabled	:= not areFieldsEnabled;
 cu_province.Enabled := not areFieldsEnabled;
 cu_salerep.Enabled:= not areFieldsEnabled;
 cu_currency.Enabled := not areFieldsEnabled;
 cu_number.Enabled	:= not areFieldsEnabled;
 cu_name1.Enabled	:= not areFieldsEnabled;
 cu_name2.Enabled	:= not areFieldsEnabled;
 cu_attn.Enabled	:= not areFieldsEnabled;
 cu_address1.Enabled	:= not areFieldsEnabled;
 cu_address2.Enabled	:= not areFieldsEnabled;
 cu_city.Enabled	:= not areFieldsEnabled;
 cu_postalcode.Enabled	:= not areFieldsEnabled;
 cu_phonenumber.Enabled	:= not areFieldsEnabled;
 cu_nationalnumber.Enabled	:= not areFieldsEnabled;
 cu_faxnumber.Enabled	:= not areFieldsEnabled;
 cu_fcs.Enabled	:= not areFieldsEnabled;
 cu_language.Enabled	:= not areFieldsEnabled;
 cu_website.Enabled	:= not areFieldsEnabled;
 cu_email.Enabled	:= not areFieldsEnabled;
 cu_emailgen.Enabled	:= not areFieldsEnabled;
 cu_emailstat.Enabled	:= not areFieldsEnabled;
 cu_provenance.Enabled	:= not areFieldsEnabled;
 cu_category.Enabled	:= not areFieldsEnabled;
 cu_category2.Enabled	:= not areFieldsEnabled;
 btn_update.Enabled := not areFieldsEnabled;
end;

procedure TForm1.updateMainFields(Sender: TObject);
var co001comp: string;
begin
Writeln('Set params');
co001comp := GetQueryParam('co001comp');
ConnectionMainFieldsPost.URI := Format(
    'http://localhost:2001/tms/xdata/CrmService/PostMainFields?insert_update=%s&co001comp=%s&cu001idno=%s&cu001nati=%s&' +
    'sl001idno=%s&cu001csuser=%s&cu001lang=%s&cu080idno=%s&cu090idno=%s&cu095idno=%s&' +
    'cu001name=%s&cu001name2=%s&cu001ref1=%s&cu001email=%s&cu001emailstat=%s&' +
    'cu001emailgen=%s&cu001attn=%s&cu001adr1=%s&cu001adr2=%s&cu001web=%s&' +
    'cu001city=%s&pv001prov=%s&co040code=%s&pv005count=%s&cu001cdpl=%s&' +
    'cu001teln=%s&cu001telext=%s&cu001fax=%s',
    [
        'U',
        co001comp,
        IfThen(cu_number.Text <> '', cu_number.Text, ''),
        IfThen(cu_nationalnumber.Text <> '', cu_nationalnumber.Text, ''),
        IfThen(cu_salerep.Text <> '', cu_salerep.Text, ''),
        IfThen(cu_fcs.Text <> '', cu_fcs.Text, ''),
        IfThen(cu_language.Text <> '', FindFirstItem(cu_language.Text), ''),
        IfThen(cu_provenance.Text <> '', FindFirstItem(cu_provenance.Text), ''),
        IfThen(cu_category.Text <> '', FindFirstItem(cu_category.Text), ''),
        IfThen(cu_category2.Text <> '', FindFirstItem(cu_category2.Text), ''),
        IfThen(cu_name1.Text <> '', cu_name1.Text, ''),
        IfThen(cu_name2.Text <> '', cu_name2.Text, ''),
        IfThen(cu_ref.Text <> '', cu_ref.Text, ''),
        IfThen(cu_email.Text <> '', cu_email.Text, ''),
        IfThen(cu_emailstat.Text <> '', cu_emailstat.Text, ''),
        IfThen(cu_emailgen.Text <> '', cu_emailgen.Text, ''),
        IfThen(cu_attn.Text <> '', cu_attn.Text, ''),
        IfThen(cu_address1.Text <> '', cu_address1.Text, ''),
        IfThen(cu_address2.Text <> '', cu_address2.Text, ''),
        IfThen(cu_website.Text <> '', cu_website.Text, ''),
        IfThen(cu_city.Text <> '', cu_city.Text, ''),
        IfThen(cu_province.Text <> '', FindFirstItem(cu_province.Text), ''),
        IfThen(cu_currency.Text <> '', FindFirstItem(cu_currency.Text), ''),
        IfThen(cu_country.Text <> '', FindFirstItem(cu_country.Text), ''),
        IfThen(cu_postalcode.Text <> '', cu_postalcode.Text, ''),
        IfThen(cu_phonenumber.Text <> '', cu_phonenumber.Text, ''),
        IfThen(cu_phonenumberext.Text <> '', cu_phonenumberext.Text, ''),
        IfThen(cu_faxnumber.Text <> '', cu_faxnumber.Text, '')
    ]
);

  Writeln(ConnectionMainFieldsPost.URI);
 ConnectionMainFieldsPost.Active := true;
end;

end.
